declare type ApiInput = {
    name: string;
    stage: string;
    auth?: {
        poolIdRef: string;
        clientIdRef: string;
    };
};
export declare const makeHttpApi: ({ name, stage, auth }: ApiInput) => {
    Resources: {
        ApiRoot: {
            Type: string;
            Properties: {
                Name: string;
                ProtocolType: string;
            };
        };
        ApiStage: {
            Type: string;
            Properties: {
                ApiId: {
                    Ref: string;
                };
                StageName: string;
                AutoDeploy: boolean;
                DefaultRouteSettings: {
                    DetailedMetricsEnabled: boolean;
                };
            };
        };
    };
    Outputs: {
        ApiUrl: {
            Description: string;
            Value: {
                'Fn::Join': (string | (string | {
                    Ref: string;
                })[])[];
            };
        };
    };
};
export {};
