declare type ApiInput = {
    route: string;
    method: string;
    functionReference: string;
    authorizerRef?: string;
};
export declare const makeHttpApiRoute: ({ route, method, functionReference, authorizerRef }: ApiInput) => {
    Resources: {
        [x: string]: {
            Type: string;
            Properties: {
                FunctionName: {
                    'Fn::GetAtt': string[];
                };
                Action: string;
                Principal: string;
                SourceArn: {
                    'Fn::Sub': string;
                };
                ApiId?: undefined;
                IntegrationType?: undefined;
                IntegrationUri?: undefined;
                PayloadFormatVersion?: undefined;
                TimeoutInMillis?: undefined;
                RouteKey?: undefined;
                Target?: undefined;
            };
            DependsOn?: undefined;
        } | {
            Type: string;
            Properties: {
                ApiId: {
                    Ref: string;
                };
                IntegrationType: string;
                IntegrationUri: {
                    'Fn::GetAtt': string[];
                };
                PayloadFormatVersion: string;
                TimeoutInMillis: number;
                FunctionName?: undefined;
                Action?: undefined;
                Principal?: undefined;
                SourceArn?: undefined;
                RouteKey?: undefined;
                Target?: undefined;
            };
            DependsOn?: undefined;
        } | {
            Type: string;
            Properties: {
                ApiId: {
                    Ref: string;
                };
                RouteKey: string;
                Target: {
                    'Fn::Join': (string | (string | {
                        Ref: string;
                    })[])[];
                };
                FunctionName?: undefined;
                Action?: undefined;
                Principal?: undefined;
                SourceArn?: undefined;
                IntegrationType?: undefined;
                IntegrationUri?: undefined;
                PayloadFormatVersion?: undefined;
                TimeoutInMillis?: undefined;
            };
            DependsOn: string[];
        };
    };
    Outputs: {};
};
export {};
