export declare type StackStatus = 'CREATE_IN_PROGRESS' | 'CREATE_FAILED' | 'CREATE_COMPLETE' | 'ROLLBACK_IN_PROGRESS' | 'ROLLBACK_FAILED' | 'ROLLBACK_COMPLETE' | 'DELETE_IN_PROGRESS' | 'DELETE_FAILED' | 'DELETE_COMPLETE' | 'UPDATE_IN_PROGRESS' | 'UPDATE_COMPLETE_CLEANUP_IN_PROGRESS' | 'UPDATE_COMPLETE' | 'UPDATE_FAILED' | 'UPDATE_ROLLBACK_IN_PROGRESS' | 'UPDATE_ROLLBACK_FAILED' | 'UPDATE_ROLLBACK_COMPLETE_CLEANUP_IN_PROGRESS' | 'UPDATE_ROLLBACK_COMPLETE' | 'REVIEW_IN_PROGRESS' | 'IMPORT_IN_PROGRESS' | 'IMPORT_COMPLETE' | 'IMPORT_ROLLBACK_IN_PROGRESS' | 'IMPORT_ROLLBACK_FAILED' | 'IMPORT_ROLLBACK_COMPLETE';
declare type StatusUpdateResource = {
    id: string;
    status: string;
    type: string;
};
declare type Resource = {
    id: string;
    status: string;
    type: string;
};
declare enum ResultStatus {
    'success' = "success",
    'fail' = "fail",
    'rollback' = "rollback",
    'inprogress' = "inprogress"
}
export declare type Output = {
    status: ResultStatus;
    message: string;
    outputs: Record<string, string>;
};
declare type RecursiveConfig = {
    stackName: string;
    minRetryInterval: number;
    maxRetryInterval: number;
    backoffRate: number;
    maxRetries: number;
    onCheck: (resources: Resource[], times: number) => void;
};
export declare type StatusUpdateInput = StatusUpdateResource[];
export declare type GetDeploymentStatusInput = {
    region?: string;
    config: RecursiveConfig;
};
export declare function getDeployStatus(props: GetDeploymentStatusInput): Promise<Output>;
export {};
