"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getDeployStatus = void 0;
var aws_sdk_1 = __importDefault(require("aws-sdk"));
var ResultStatus;
(function (ResultStatus) {
    ResultStatus["success"] = "success";
    ResultStatus["fail"] = "fail";
    ResultStatus["rollback"] = "rollback";
    ResultStatus["inprogress"] = "inprogress";
})(ResultStatus || (ResultStatus = {}));
var stackStateMap = {
    CREATE_IN_PROGRESS: ResultStatus.inprogress,
    CREATE_FAILED: ResultStatus.fail,
    CREATE_COMPLETE: ResultStatus.success,
    ROLLBACK_IN_PROGRESS: ResultStatus.inprogress,
    ROLLBACK_FAILED: ResultStatus.fail,
    ROLLBACK_COMPLETE: ResultStatus.rollback,
    DELETE_IN_PROGRESS: ResultStatus.inprogress,
    DELETE_FAILED: ResultStatus.fail,
    DELETE_COMPLETE: ResultStatus.success,
    UPDATE_IN_PROGRESS: ResultStatus.inprogress,
    UPDATE_COMPLETE_CLEANUP_IN_PROGRESS: ResultStatus.inprogress,
    UPDATE_COMPLETE: ResultStatus.success,
    UPDATE_FAILED: ResultStatus.fail,
    UPDATE_ROLLBACK_IN_PROGRESS: ResultStatus.inprogress,
    UPDATE_ROLLBACK_FAILED: ResultStatus.fail,
    UPDATE_ROLLBACK_COMPLETE_CLEANUP_IN_PROGRESS: ResultStatus.inprogress,
    UPDATE_ROLLBACK_COMPLETE: ResultStatus.rollback,
    REVIEW_IN_PROGRESS: ResultStatus.inprogress,
    IMPORT_IN_PROGRESS: ResultStatus.inprogress,
    IMPORT_COMPLETE: ResultStatus.success,
    IMPORT_ROLLBACK_IN_PROGRESS: ResultStatus.inprogress,
    IMPORT_ROLLBACK_FAILED: ResultStatus.fail,
    IMPORT_ROLLBACK_COMPLETE: ResultStatus.rollback
};
var getStackInfo = function (region) { return function (name) { return __awaiter(void 0, void 0, void 0, function () {
    var cloudformation, params, result, e_1, message;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                cloudformation = new aws_sdk_1.default.CloudFormation({
                    region: region
                });
                params = {
                    StackName: name
                };
                _a.label = 1;
            case 1:
                _a.trys.push([1, 3, , 4]);
                return [4, cloudformation.describeStacks(params).promise()];
            case 2:
                result = _a.sent();
                if (!result.Stacks || result.Stacks.length === 0) {
                    throw new Error('No stacks found with the name ' + name);
                }
                return [2, result.Stacks[0]];
            case 3:
                e_1 = _a.sent();
                message = e_1 instanceof Error
                    ? e_1.message
                    : 'Something unexpected has gone wrong';
                throw new Error(message);
            case 4: return [2];
        }
    });
}); }; };
var getStackResourceStatus = function (region) { return function (name) { return __awaiter(void 0, void 0, void 0, function () {
    var cloudformation, params, result, e_2, message;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                cloudformation = new aws_sdk_1.default.CloudFormation({
                    region: region
                });
                params = {
                    StackName: name
                };
                _a.label = 1;
            case 1:
                _a.trys.push([1, 3, , 4]);
                return [4, cloudformation
                        .describeStackResources(params)
                        .promise()];
            case 2:
                result = _a.sent();
                if (!result.StackResources) {
                    throw new Error('No stack resources found');
                }
                return [2, result.StackResources];
            case 3:
                e_2 = _a.sent();
                message = e_2 instanceof Error
                    ? e_2.message
                    : 'Something unexpected has gone wrong';
                throw new Error(message);
            case 4: return [2];
        }
    });
}); }; };
function getCloudFormationStackInfo(getInfo, name) {
    return __awaiter(this, void 0, void 0, function () {
        var data, status, message, outputs, stackInfoStatus;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, getInfo(name)];
                case 1:
                    data = _a.sent();
                    status = data.StackStatus;
                    message = data.StackStatusReason || 'unknown';
                    outputs = data.Outputs || [];
                    stackInfoStatus = stackStateMap[status] || ResultStatus.fail;
                    return [2, {
                            status: stackInfoStatus,
                            message: message,
                            outputs: outputs.map(function (o) {
                                if (!o.OutputKey) {
                                    throw new Error('Output does not have a key');
                                }
                                if (!o.OutputValue) {
                                    throw new Error('Output does not have a key');
                                }
                                return {
                                    key: o.OutputKey,
                                    value: o.OutputValue
                                };
                            })
                        }];
            }
        });
    });
}
function checkAgainState(io, config, timer, times) {
    return __awaiter(this, void 0, void 0, function () {
        var wait, resourceProgress, resources, increasedTimer, newTimer;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    wait = function (time) {
                        return new Promise(function (r) { return setTimeout(function () { return r(); }, time); });
                    };
                    return [4, wait(timer)];
                case 1:
                    _a.sent();
                    return [4, io.getResources(config.stackName)];
                case 2:
                    resourceProgress = _a.sent();
                    resources = resourceProgress.map(function (x) { return ({
                        id: x.LogicalResourceId,
                        status: x.ResourceStatus,
                        type: x.ResourceType
                    }); });
                    config.onCheck(resources, times);
                    increasedTimer = timer * config.backoffRate;
                    newTimer = increasedTimer > config.maxRetryInterval
                        ? config.maxRetryInterval
                        : increasedTimer;
                    return [4, recursiveCheck(io, config, times + 1, newTimer)];
                case 3: return [2, _a.sent()];
            }
        });
    });
}
function stillInProgressState() {
    return {
        status: ResultStatus.inprogress,
        message: 'Cloudformation is still deploying...',
        outputs: {}
    };
}
function failState(message) {
    return {
        status: ResultStatus.fail,
        message: message,
        outputs: {}
    };
}
function completeState(stackInfo) {
    if (stackInfo.status === ResultStatus.rollback) {
        return {
            status: ResultStatus.rollback,
            message: 'Rollback Complete',
            outputs: stackInfo.outputs.reduce(function (acc, x) {
                acc[x.key] = x.value;
                return acc;
            }, {})
        };
    }
    return {
        status: ResultStatus.success,
        message: 'Deployment Successful',
        outputs: stackInfo.outputs.reduce(function (acc, x) {
            acc[x.key] = x.value;
            return acc;
        }, {})
    };
}
function unknownState() {
    return {
        status: 'fail',
        message: 'Cloudformation is in an unknown state',
        outputs: {}
    };
}
function recursiveCheck(io, config, times, timer) {
    return __awaiter(this, void 0, void 0, function () {
        var stackInfo;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, getCloudFormationStackInfo(io.getInfo, config.stackName)];
                case 1:
                    stackInfo = _a.sent();
                    if (times === config.maxRetries) {
                        return [2, stillInProgressState()];
                    }
                    if (!stackInfo.status.includes(ResultStatus.inprogress)) return [3, 3];
                    return [4, checkAgainState(io, config, timer, times)];
                case 2: return [2, _a.sent()];
                case 3:
                    if ([ResultStatus.fail, ResultStatus.rollback].includes(stackInfo.status)) {
                        return [2, failState(stackInfo.message)];
                    }
                    if (stackInfo.status.includes(ResultStatus.success)) {
                        return [2, completeState(stackInfo)];
                    }
                    return [2, unknownState()];
            }
        });
    });
}
function getDeployStatus(props) {
    return __awaiter(this, void 0, void 0, function () {
        var region;
        return __generator(this, function (_a) {
            region = props.region || process.env.AWS_REGION || 'us-east-1';
            return [2, recursiveCheck({
                    getInfo: getStackInfo(region),
                    getResources: getStackResourceStatus(region)
                }, props.config, 1, props.config.minRetryInterval)];
        });
    });
}
exports.getDeployStatus = getDeployStatus;
