export declare function makeArtifactBucket(name: string): {
    Resources: {
        CodePipelineArtifactStoreBucket: {
            Type: string;
            DeletionPolicy: string;
            UpdateReplacePolicy: string;
            Properties: {
                VersioningConfiguration: {
                    Status: string;
                };
                BucketEncryption: {
                    ServerSideEncryptionConfiguration: {
                        ServerSideEncryptionByDefault: {
                            SSEAlgorithm: string;
                        };
                    }[];
                };
            };
        };
        CodePipelineArtifactStoreBucketPolicy: {
            Type: string;
            Properties: {
                Bucket: {
                    Ref: string;
                };
                PolicyDocument: {
                    Version: string;
                    Statement: ({
                        Sid: string;
                        Effect: string;
                        Principal: string;
                        Action: string;
                        Resource: {
                            'Fn::Join': (string | (string | {
                                'Fn::GetAtt': string[];
                            })[])[];
                        };
                        Condition: {
                            StringNotEquals: {
                                's3:x-amz-server-side-encryption': string;
                            };
                            Bool?: undefined;
                        };
                    } | {
                        Sid: string;
                        Effect: string;
                        Principal: string;
                        Action: string;
                        Resource: {
                            'Fn::Join': (string | (string | {
                                'Fn::GetAtt': string[];
                            })[])[];
                        };
                        Condition: {
                            Bool: {
                                'aws:SecureTransport': boolean;
                            };
                            StringNotEquals?: undefined;
                        };
                    })[];
                };
            };
        };
    };
};
