export declare function makeBuildProject(props: {
    name: string;
    buildSpec: string;
    env: Record<string, string>;
}): {
    Resources: {
        [x: string]: {
            Type: string;
            Properties: {
                Artifacts: {
                    Type: string;
                };
                Environment: {
                    Type: string;
                    ComputeType: string;
                    Image: string;
                    PrivilegedMode: boolean;
                };
                ServiceRole: {
                    'Fn::GetAtt': string[];
                };
                Name: string;
                QueuedTimeoutInMinutes: number;
                Source: {
                    Type: string;
                    BuildSpec: string;
                };
                AssumeRolePolicyDocument?: undefined;
                Path?: undefined;
                Policies?: undefined;
            };
        } | {
            Type: string;
            Properties: {
                AssumeRolePolicyDocument: {
                    Version: string;
                    Statement: {
                        Effect: string;
                        Action: string;
                        Principal: {
                            Service: string[];
                        };
                    }[];
                };
                Path: string;
                Policies: ({
                    PolicyName: string;
                    PolicyDocument: {
                        Version: string;
                        Statement: {
                            Effect: string;
                            Action: string[];
                            Resource: (string | {
                                'Fn::Sub': string;
                            })[];
                        }[];
                    };
                } | {
                    PolicyName: string;
                    PolicyDocument: {
                        Version: string;
                        Statement: {
                            Effect: string;
                            Action: string[];
                            Resource: string;
                        }[];
                    };
                } | {
                    PolicyName: string;
                    PolicyDocument: {
                        Version: string;
                        Statement: ({
                            Effect: string;
                            Action: string[];
                            Resource: string[];
                        } | {
                            Effect: string;
                            Action: string;
                            Resource: string;
                        })[];
                    };
                })[];
                Artifacts?: undefined;
                Environment?: undefined;
                ServiceRole?: undefined;
                Name?: undefined;
                QueuedTimeoutInMinutes?: undefined;
                Source?: undefined;
            };
        };
        CodeBuildServiceRole: {
            Type: string;
            Properties: {
                AssumeRolePolicyDocument: {
                    Version: string;
                    Statement: {
                        Effect: string;
                        Action: string;
                        Principal: {
                            Service: string[];
                        };
                    }[];
                };
                Path: string;
                Policies: ({
                    PolicyName: string;
                    PolicyDocument: {
                        Version: string;
                        Statement: {
                            Effect: string;
                            Action: string[];
                            Resource: (string | {
                                'Fn::Sub': string;
                            })[];
                        }[];
                    };
                } | {
                    PolicyName: string;
                    PolicyDocument: {
                        Version: string;
                        Statement: {
                            Effect: string;
                            Action: string[];
                            Resource: string;
                        }[];
                    };
                } | {
                    PolicyName: string;
                    PolicyDocument: {
                        Version: string;
                        Statement: ({
                            Effect: string;
                            Action: string[];
                            Resource: string[];
                        } | {
                            Effect: string;
                            Action: string;
                            Resource: string;
                        })[];
                    };
                })[];
            };
        };
    };
};
