export declare const makeCognito: (appName: string, stage: string) => {
    Resources: {
        CognitoUserPool: {
            Type: string;
            Properties: {
                UserPoolName: string;
                AdminCreateUserConfig: {
                    AllowAdminCreateUserOnly: boolean;
                    UnusedAccountValidityDays: number;
                };
            };
        };
        CognitoUserPoolClient: {
            Type: string;
            Properties: {
                ClientName: string;
                UserPoolId: {
                    Ref: string;
                };
                ExplicitAuthFlows: string[];
                GenerateSecret: boolean;
            };
        };
    };
    Outputs: {
        UserPoolId: {
            Value: {
                Ref: string;
            };
        };
        UserPoolClientId: {
            Value: {
                Ref: string;
            };
        };
    };
};
