"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getKeyword = void 0;
var aws_sdk_1 = __importDefault(require("aws-sdk"));
var getOutput = function (str, region) { return __awaiter(void 0, void 0, void 0, function () {
    var cloudformation, stack, value, params, res, outputs;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                cloudformation = new aws_sdk_1.default.CloudFormation({
                    region: region
                });
                stack = str.split('.')[1];
                value = str.split('.')[2];
                params = {
                    StackName: stack
                };
                return [4, cloudformation.describeStacks(params).promise()];
            case 1:
                res = _a.sent();
                if (!res.Stacks) {
                    throw new Error('There as an issue describing stack: ' + stack);
                }
                outputs = res.Stacks[0].Outputs;
                if (outputs.map(function (x) { return x.OutputKey; }).includes(value)) {
                    return [2, outputs.map(function (x) { return ({
                            key: x.OutputKey,
                            stack: stack,
                            value: x.OutputValue
                        }); })];
                }
                else {
                    throw new Error("".concat(str, " not found"));
                }
                return [2];
        }
    });
}); };
var getSsmParam = function (str, region) { return __awaiter(void 0, void 0, void 0, function () {
    var v, ssm, params, res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                v = str.split('.')[1];
                ssm = new aws_sdk_1.default.SSM({
                    region: region
                });
                params = {
                    Name: v
                };
                return [4, ssm.getParameter(params).promise()];
            case 1:
                res = _a.sent();
                if (!res.Parameter) {
                    throw new Error('There as an issue getting param: ' + v);
                }
                return [2, res.Parameter.Value];
        }
    });
}); };
var getAccountId = function () { return __awaiter(void 0, void 0, void 0, function () {
    var sts, res;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                sts = new aws_sdk_1.default.STS();
                return [4, sts.getCallerIdentity({}).promise()];
            case 1:
                res = _a.sent();
                return [2, res.Account];
        }
    });
}); };
function getKeyword(state, str) {
    return __awaiter(this, void 0, void 0, function () {
        var valueResultsMap, region, getString, result;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    valueResultsMap = state;
                    if (!state['@stage']) {
                        valueResultsMap['@stage'] = 'dev';
                    }
                    if (!state['@region']) {
                        valueResultsMap['@region'] = 'us-east-1';
                    }
                    region = valueResultsMap['@region'];
                    getString = function (value) { return __awaiter(_this, void 0, void 0, function () {
                        var stringToUse_1, replaceText_2, replaceIndex_1, replace_1, _i, replaceText_1, r, outputs, theOutput, accountId, theOutput, v;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    if (!(value.includes('{') && value.includes('}'))) return [3, 12];
                                    stringToUse_1 = '';
                                    replaceText_2 = [];
                                    replaceIndex_1 = -1;
                                    replace_1 = false;
                                    value.split('').forEach(function (ch, i, l) {
                                        if (l[i] === '{' && l[i + 1] === '@') {
                                            replaceIndex_1++;
                                            replace_1 = true;
                                        }
                                        else if (l[i] === '}' && replace_1) {
                                            replace_1 = false;
                                        }
                                        else {
                                            stringToUse_1 = stringToUse_1 + ch;
                                            if (replace_1) {
                                                if (!replaceText_2[replaceIndex_1]) {
                                                    replaceText_2[replaceIndex_1] = ch;
                                                }
                                                else {
                                                    replaceText_2[replaceIndex_1] = replaceText_2[replaceIndex_1] + ch;
                                                }
                                            }
                                        }
                                    });
                                    _i = 0, replaceText_1 = replaceText_2;
                                    _a.label = 1;
                                case 1:
                                    if (!(_i < replaceText_1.length)) return [3, 11];
                                    r = replaceText_1[_i];
                                    if (r.startsWith('@stage')) {
                                        stringToUse_1 = stringToUse_1.replace(r, valueResultsMap['@stage']);
                                    }
                                    if (r.startsWith('@region')) {
                                        stringToUse_1 = stringToUse_1.replace(r, valueResultsMap['@region']);
                                    }
                                    if (!r.startsWith('@output')) return [3, 4];
                                    if (!valueResultsMap[r]) return [3, 2];
                                    stringToUse_1 = stringToUse_1.replace(r, valueResultsMap[r]);
                                    return [3, 4];
                                case 2: return [4, getOutput(r, region)];
                                case 3:
                                    outputs = _a.sent();
                                    outputs.forEach(function (x) {
                                        valueResultsMap["@output.".concat(x.stack, ".").concat(x.key)] = x.value;
                                    });
                                    theOutput = valueResultsMap[r];
                                    stringToUse_1 = stringToUse_1.replace(r, theOutput);
                                    _a.label = 4;
                                case 4:
                                    if (!r.startsWith('@accountId')) return [3, 7];
                                    if (!valueResultsMap[r]) return [3, 5];
                                    stringToUse_1 = stringToUse_1.replace(r, valueResultsMap[r]);
                                    return [3, 7];
                                case 5: return [4, getAccountId()];
                                case 6:
                                    accountId = (_a.sent()) || '';
                                    valueResultsMap["@accountId"] = accountId;
                                    theOutput = accountId;
                                    stringToUse_1 = stringToUse_1.replace(r, theOutput);
                                    _a.label = 7;
                                case 7:
                                    if (!r.startsWith('@ssm')) return [3, 10];
                                    if (!valueResultsMap[r]) return [3, 8];
                                    stringToUse_1 = stringToUse_1.replace(r, valueResultsMap[r]);
                                    return [3, 10];
                                case 8: return [4, getSsmParam(r, region)];
                                case 9:
                                    v = (_a.sent()) || '';
                                    valueResultsMap[r] = v;
                                    stringToUse_1 = stringToUse_1.replace(r, v);
                                    _a.label = 10;
                                case 10:
                                    _i++;
                                    return [3, 1];
                                case 11: return [2, stringToUse_1];
                                case 12: return [2, value];
                            }
                        });
                    }); };
                    return [4, getString(str)];
                case 1:
                    result = _a.sent();
                    return [2, {
                            result: result,
                            state: valueResultsMap
                        }];
            }
        });
    });
}
exports.getKeyword = getKeyword;
