"use strict";
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.makeInlineLambda = void 0;
function makeInlineLambda(props) {
    var _a;
    var basePermissions = [
        {
            Action: ['logs:CreateLogStream'],
            Resource: [
                {
                    'Fn::Sub': [
                        "arn:aws:logs:${AWS::Region}:${AWS::AccountId}:log-group:/aws/lambda/".concat(props.appName, "-").concat(props.name, "-").concat(props.stage, ":*"),
                        {}
                    ]
                }
            ],
            Effect: 'Allow'
        },
        {
            Action: ['logs:PutLogEvents'],
            Resource: [
                {
                    'Fn::Sub': [
                        "arn:aws:logs:${AWS::Region}:${AWS::AccountId}:log-group:/aws/lambda/".concat(props.appName, "-").concat(props.name, "-").concat(props.stage, ":*:*"),
                        {}
                    ]
                }
            ],
            Effect: 'Allow'
        }
    ];
    var permissions = __spreadArray(__spreadArray([], basePermissions, true), props.permissions, true);
    return {
        Resources: (_a = {},
            _a["Lambda".concat(props.name).concat(props.stage, "LogGroup")] = {
                Type: 'AWS::Logs::LogGroup',
                Properties: {
                    LogGroupName: "/aws/lambda/".concat(props.appName, "-").concat(props.name, "-").concat(props.stage)
                }
            },
            _a["Lambda".concat(props.name).concat(props.stage)] = {
                Type: 'AWS::Lambda::Function',
                Properties: {
                    Code: {
                        ZipFile: props.code
                    },
                    FunctionName: "".concat(props.appName, "-").concat(props.name, "-").concat(props.stage),
                    Handler: props.handler || 'index.handler',
                    MemorySize: 1024,
                    Role: {
                        'Fn::GetAtt': [
                            "Lambda".concat(props.name).concat(props.stage, "Role"),
                            'Arn'
                        ]
                    },
                    Runtime: 'nodejs14.x',
                    Timeout: props.timeout || 6,
                    Environment: {
                        Variables: props.env || {}
                    }
                },
                DependsOn: ["Lambda".concat(props.name).concat(props.stage, "LogGroup")]
            },
            _a["Lambda".concat(props.name).concat(props.stage, "Role")] = {
                Type: 'AWS::IAM::Role',
                Properties: {
                    AssumeRolePolicyDocument: {
                        Version: '2012-10-17',
                        Statement: [
                            {
                                Effect: 'Allow',
                                Principal: {
                                    Service: ['lambda.amazonaws.com']
                                },
                                Action: ['sts:AssumeRole']
                            }
                        ]
                    },
                    Policies: [
                        {
                            PolicyName: "Lambda".concat(props.appName).concat(props.name).concat(props.stage, "RolePolicy"),
                            PolicyDocument: {
                                Version: '2012-10-17',
                                Statement: permissions
                            }
                        }
                    ],
                    Path: '/',
                    RoleName: "Lambda".concat(props.appName).concat(props.name).concat(props.stage, "Role")
                }
            },
            _a),
        Outputs: {}
    };
}
exports.makeInlineLambda = makeInlineLambda;
