export default function makeBucket(name: string): {
    Resources: {
        [x: string]: {
            Type: string;
            Properties: {
                BucketEncryption: {
                    ServerSideEncryptionConfiguration: {
                        ServerSideEncryptionByDefault: {
                            SSEAlgorithm: string;
                        };
                    }[];
                };
                Bucket?: undefined;
                PolicyDocument?: undefined;
            };
        } | {
            Type: string;
            Properties: {
                Bucket: {
                    Ref: string;
                };
                PolicyDocument: {
                    Statement: {
                        Action: string;
                        Effect: string;
                        Principal: string;
                        Resource: {
                            'Fn::Join': (string | (string | {
                                Ref: string;
                            })[])[];
                        }[];
                        Condition: {
                            Bool: {
                                'aws:SecureTransport': boolean;
                            };
                        };
                    }[];
                };
                BucketEncryption?: undefined;
            };
        };
    };
    Outputs: {
        [x: string]: {
            Value: {
                Ref: string;
            };
        };
    };
};
